package hdl

import (
	"applet/app/bigData/lib/validate"
	"applet/app/bigData/md"
	"applet/app/bigData/svc"
	"applet/app/e"
	"applet/app/enum"
	svc2 "applet/app/svc"
	"applet/app/utils"
	"fmt"
	"github.com/gin-gonic/gin"
)

func Login(c *gin.Context) {
	var req md.LoginReq
	err := c.ShouldBindJSON(&req)
	if err != nil {
		err = validate.HandleValidateErr(err)
		err1 := err.(e.E)
		e.OutErr(c, err1.Code, err1.Error())
		return
	}
	sysCfg := svc2.SysCfgFind(enum.BigDataScreenAccount, enum.BigDataScreenPassword)
	if sysCfg[enum.BigDataScreenAccount] == "" || sysCfg[enum.BigDataScreenPassword] == "" {
		e.OutErr(c, e.ERR_NO_DATA, "用户信息不存在")
		return
	}

	if sysCfg[enum.BigDataScreenAccount] != req.Account || sysCfg[enum.BigDataScreenPassword] != req.Password {
		e.OutErr(c, e.ERR_NO_DATA, "账号或密码错误")
		return
	}

	ip := utils.GetIP(c.Request)
	key := fmt.Sprintf(md.UserJwtTokenKey, ip, req.LoginKind)
	token, err := svc.HandleLoginToken(key, &md.User{
		Account:   req.Account,
		Password:  req.Password,
		LoginKind: req.LoginKind,
	})
	if err != nil {
		e.OutErr(c, e.ERR, err.Error())
		return
	}
	e.OutSuc(c, md.LoginResponse{
		Token:     token,
		LoginKind: req.LoginKind,
	}, nil)
	return
}

func UserInfo(c *gin.Context) {
	//1、获取用户信息
	userInfo := svc.GetUser(c)

	e.OutSuc(c, map[string]interface{}{
		"user_info": userInfo,
	}, nil)
	return
}
