package mw

import (
	"applet/app/e"
	"applet/app/ipad/svc"
	"github.com/gin-gonic/gin"
)

// 检查权限, 签名等等
func Auth(c *gin.Context) {
	user, err := svc.CheckUser(c)
	if err != nil {
		switch err.(type) {
		case e.E:
			err1 := err.(e.E)
			e.OutErr(c, err1.Code, err1.Error())
			return
		default:
			e.OutErr(c, e.ERR_UNAUTHORIZED, err.Error())
			return
		}
	}
	if user == nil {
		e.OutErr(c, e.ERR_NOT_AUTH, "当前用户信息失效")
		return
	}
	// 将当前请求的username信息保存到请求的上下文c上
	c.Set("user", user)
	c.Next()
}
